/* $Id: parse.c 13 2023-02-26 05:36:15Z nishi $ */
#include <nikkel/parse.h>

#include <nikkel/config.h>
#include <nikkel/util.h>

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <dirent.h>

struct nikkel_entry {
	char* name;
	char* original_name;
	char* prefix;
	char* entryprefix;
	char letter;
};

#define CHECK_NULL	if(value == NULL){\
				free(result->p_title);\
				char* err = malloc(513);\
				memset(err, 0, 513);\
				sprintf(err, "<span class=\"special-message\"><span class=\"color-red\">&emsp;</span><span class=\"special-error\">ERROR</span>: Line number %d: `%s` needs the argument<span class=\"color-red\">&emsp;</span></span>", line, key);\
				result->p_title = sstrdup("Error");\
				char* tmp_body = result->p_body;\
				result->p_body = sstrcat(tmp_body, err);\
				free(tmp_body);\
				free(err);\
				break;\
			}

struct nikkel_parsed* nikkel_parse(struct nikkel_config* config, FILE* f){
	struct nikkel_parsed* result = malloc(sizeof(*result));
	result->p_title = sstrdup("No Title");
	int counter = 0;
	char ch;
	char* buffer = malloc(1);
	buffer[0] = 0;
	result->p_body = malloc(1);
	result->p_pagetitle = NULL;
	result->p_body[0] = 0;
	result->p_category = malloc(sizeof(*result->p_category));
	result->p_category[0] = NULL;
	int category_count = 0;
	int line = 0;
	char code = 0;
	while(1){
		fread(&ch, 1, 1, f);
		if(feof(f) || ch == '\n'){
			line++;
			if(counter != 0){
				int i;
				char sbracket = 0;
				char* ch = malloc(2);
				ch[0] = 0;
				ch[1] = 0;
				char* sbracket_buffer = malloc(1);
				sbracket_buffer[0] = 0;
				int start_sbracket = 0;
				int font_bold = 0;
				int font_italic = 0;
				for(i = 0; buffer[i] != 0; i++){
					ch[0] = buffer[i];
					if(sbracket == 1){
						if(ch[0] == ']'){
							char assign = 0;
							int j;
							for(j = start_sbracket; j < i; j++){
								if(buffer[j] == '|'){
									assign = 1;
									break;
								}
							}
							{
								char* orig_buffer = sstrdup(buffer);
								char* key = buffer + start_sbracket + 1;
								key[j - 1 - start_sbracket] = 0;
								char* value = NULL;
								if(assign == 1){
									value = sstrdup(buffer + j + 1);
									value[i - start_sbracket - sstrlen(key) - 2] = 0;
								}
								if(code == 1){
									if(strcmp(key, "/Code") == 0){
										code = 0;
										char* tmp = result->p_body;
										result->p_body = sstrcat(tmp, "</code></pre>");
										free(tmp);
									}else{
										char* tmp = result->p_body;
										result->p_body = sstrcat4(tmp, "[", sbracket_buffer, "]");
										free(tmp);
									}
									if(value != NULL) free(value);
									goto clean_sbracket;
								}
								if(strcmp(key, "Title") == 0){
									CHECK_NULL;
									free(result->p_title);
									result->p_title = sstrdup(value);
								}else if(strcmp(key, "PageTitle") == 0){
									CHECK_NULL;
									if(result->p_pagetitle != NULL) free(result->p_pagetitle);
									result->p_pagetitle = sstrdup(value);
								}else if(strcmp(key, "Section") == 0){
									CHECK_NULL;
									char* tmp = result->p_body;
									char* replaced = sreplace(value, ' ', '-');
									char* start = sstrcat3("<h3 id=\"section-", replaced, "\">");
									char* more = sstrcat4(value, " <a href=\"#section-", replaced, "\">&#167;</a>");
									result->p_body = sstrcat4(tmp, start, more, "</h3>\n<hr>\n");
									free(more);
									free(start);
									free(replaced);
									free(tmp);
								}else if(strcmp(key, "Link") == 0 || strcmp(key, "Entry") == 0 || strcmp(key, "Image") == 0){
									CHECK_NULL;
									char* link = malloc(1);
									link[0] = 0;
									char* name = malloc(1);
									name[0] = 0;
									int index = -1;
									for(j = 0; value[j] != 0; j++){
										if(value[j] == '|'){
											index = j;
											break;
										}
									}
									if(index == -1){
										free(link);
										link = sstrdup(value);
									}else{
										free(link);
										free(name);
										value[index] = 0;
										link = sstrdup(value);
										name = sstrdup(value + index + 1);
									}
									if(strcmp(key, "Entry") == 0){
										char* tmp = link;
										link = sstrcat4(config->c_prefix, "/", link, ".wiki");
										free(tmp);
									}
									if(strcmp(key, "Image") == 0){
										char* tmp = result->p_body;
										result->p_body = sstrcat4(tmp, "<span class=\"image-container\"><a href=\"", link, "\">");
										free(tmp);

										tmp = result->p_body;
										result->p_body = sstrcat4(tmp, "<img src=\"", link, "\"");
										free(tmp);
										if(name[0] != 0){
											tmp = result->p_body;
											result->p_body = sstrcat4(tmp, " alt=\"", name, "\"");
											free(tmp);
										}
										tmp = result->p_body;
										result->p_body = sstrcat4(tmp, "></a><div>", name, "</div></span>");
										free(tmp);
									}else{
										char* tmp = result->p_body;
										result->p_body = sstrcat4(tmp, "<a href=\"", link, "\">");
										free(tmp);
										tmp = result->p_body;
										result->p_body = sstrcat3(tmp, (index == -1 ? link : name), "</a>");
										free(tmp);
									}
									free(name);
									free(link);
								}else if(strcmp(key, "Category") == 0){
									CHECK_NULL;
									int j = 0;
									char* buf = malloc(1);
									buf[0] = 0;
									int counter = 0;
									while(1){
										char ch = value[j];
										if(ch == 0 || ch == '|'){
											if(counter != 0){
												result->p_category = realloc(result->p_category, sizeof(*result->p_category) * (category_count + 2));
												result->p_category[category_count] = sstrdup(buf);
												result->p_category[category_count + 1] = NULL;
												category_count++;
											}
											free(buf);
											buf = malloc(1);
											buf[0] = 0;
											counter = 0;
											if(ch == 0) break;
										}else{
											buf = realloc(buf, counter + 2);
											buf[counter] = ch;
											buf[counter + 1] = 0;
											counter++;
										}
										j++;
									}
									free(buf);
								}else if(strcmp(key, "Bold") == 0 || strcmp(key, "/Bold") == 0){
									char* tmp = result->p_body;
									if(strcmp(key, "Bold") == 0){
										result->p_body = sstrcat(tmp, "<span class=\"font-bold\">");
										font_bold++;
									}else{
										result->p_body = sstrcat(tmp, "</span>");
										font_bold--;
									}
									free(tmp);
								}else if(strcmp(key, "Italic") == 0 || strcmp(key, "/Italic") == 0){
									char* tmp = result->p_body;
									if(strcmp(key, "Italic") == 0){
										result->p_body = sstrcat(tmp, "<span class=\"font-italic\">");
										font_italic++;
									}else{
										result->p_body = sstrcat(tmp, "</span>");
										font_italic--;
									}
									free(tmp);
								}else if(strcmp(key, "Code") == 0){
									code = 1;
									char* tmp = result->p_body;
									result->p_body = sstrcat(tmp, "<pre><code>");
									free(tmp);
								}
								if(value != NULL) free(value);
							}
clean_sbracket:
							sbracket = 0;
							free(sbracket_buffer);
							sbracket_buffer = malloc(1);
							sbracket_buffer[0] = 0;
						}else{
							char* tmp = sbracket_buffer;
							sbracket_buffer = sstrcat(tmp, ch);
							free(tmp);
						}
						continue;
					}
					if(ch[0] == '['){
						sbracket = 1;
						start_sbracket = i;
					}else{
						char* tmp = result->p_body;
						if(ch[0] == '<'){
							result->p_body = sstrcat(tmp, "&lt;");
						}else if(ch[0] == '>'){
							result->p_body = sstrcat(tmp, "&gt;");
						}else if(ch[0] == '&'){
							result->p_body = sstrcat(tmp, "&amp;");
						}else if(ch[0] == '\\'){
							if(buffer[i + 1] != 0){
								ch[0] = buffer[i + 1];
								result->p_body = sstrcat(tmp, ch);
								i++;
							}else{
								char* err = malloc(513);
								memset(err, 0, 513);
								sprintf(err, "<span class=\"special-message\"><span class=\"color-yellow\">&emsp;</span><span class=\"special-warn\">WARN</span>: Line number %d: Stray backslash found at the end of the line.<span class=\"color-yellow\">&emsp;</span></span><br>", line);
								result->p_body = sstrcat(tmp, err);
								free(err);
							}
						}else{
							result->p_body = sstrcat(tmp, ch);
						}
						free(tmp);
					}
				}
				if(font_bold != 0){
					char* tmp = result->p_body;
					result->p_body = sstrcat(tmp, "</span>");
					free(tmp);
				}
				if(font_italic != 0){
					char* tmp = result->p_body;
					result->p_body = sstrcat(tmp, "</span>");
					free(tmp);
				}
				if(font_bold != 0){
					char* err = malloc(513);
					memset(err, 0, 513);
					sprintf(err, "<span class=\"special-message\"><span class=\"color-yellow\">&emsp;</span><span class=\"special-warn\">WARN</span>: Line number %d: `Bold` is not closed, so not rendering.<span class=\"color-yellow\">&emsp;</span></span><br>", line);
					char* tmp = result->p_body;
					result->p_body = sstrcat(tmp, err);
					free(tmp);
					free(err);
				}
				if(font_italic != 0){
					char* err = malloc(513);
					memset(err, 0, 513);
					sprintf(err, "<span class=\"special-message\">&emsp;<span class=\"special-warn\">WARN</span>: Line number %d: `Italic` is not closed, so not rendering.&emsp;</span><br>", line);
					char* tmp = result->p_body;
					result->p_body = sstrcat(tmp, err);
					free(tmp);
					free(err);
				}
				free(sbracket_buffer);
				free(ch);
			}else{
				char* tmp = result->p_body;
				if(code == 1){
					result->p_body = sstrcat(tmp, "\n");
				}else{
					result->p_body = sstrcat(tmp, "<br>\n");
				}
				free(tmp);
			}
			if(counter != 0 && code == 1){
				char* tmp = result->p_body;
				result->p_body = sstrcat(tmp, "\n");
				free(tmp);
			}
			free(buffer);
			buffer = malloc(1);
			buffer[0] = 0;
			counter = 0;
			if(feof(f)) break;
		}else{
			buffer = realloc(buffer, counter + 2);
			buffer[counter] = ch;
			buffer[counter + 1] = 0;
			counter++;
		}
	}
	free(buffer);
	return result;
}

void nikkel_parsed_free(struct nikkel_parsed* parsed){
	free(parsed->p_title);
	free(parsed->p_body);
	int i;
	for(i = 0; parsed->p_category[i] != NULL; i++){
		free(parsed->p_category[i]);
	}
	free(parsed->p_category);
	if(parsed->p_pagetitle != NULL) free(parsed->p_pagetitle);
	free(parsed);
}

void nikkel_dir(const char* dirpath, struct nikkel_entry*** entries, int* entry_count, const char* category, const char* prefix, const char* entryprefix){
	DIR* dir = opendir(dirpath);
	if(dir != NULL){
		struct dirent* d;
		while((d = readdir(dir)) != NULL){
			if(d->d_name[0] == '.'){
				continue;
			}
			char* stat_path = sstrcat3(dirpath, "/", d->d_name);
			struct stat s;
			stat(stat_path, &s);
			free(stat_path);
			if(S_ISDIR(s.st_mode)){
				stat_path = sstrcat3(dirpath, "/", d->d_name);
				char* dir_prefix = sstrcat3(prefix, "/", d->d_name);
				char* dir_entryprefix = sstrcat3(entryprefix, d->d_name, "/");
				nikkel_dir(stat_path, entries, entry_count, category, dir_prefix, dir_entryprefix);
				free(dir_entryprefix);
				free(dir_prefix);
				free(stat_path);
			}else if(S_ISREG(s.st_mode)){
				char* fmt_name = sstrdup(d->d_name);
				fmt_name[sstrlen(fmt_name) - sstrlen(".wiki")] = 0;
				char* name = sstrdup(fmt_name);
				free(fmt_name);
				char* orig_name = sstrdup(name);
				char** categories = malloc(sizeof(*categories));
				categories[0] = NULL;
				int category_count = 0;
				char* path = sstrcat3(dirpath, "/", d->d_name);
				FILE* f = fopen(path, "r");
				if(f != NULL){
					int counter = 0;
					char* buffer = malloc(1);
					buffer[0] = 0;
					char ch;
					while(1){
						fread(&ch, 1, 1, f);
						if(feof(f) || ch == '\n'){
							if(counter != 0){
								int i;
								char sbracket = 0;
								char* chb = malloc(2);
								chb[0] = 0;
								chb[1] = 0;
								char* sbracket_buffer = malloc(1);
								sbracket_buffer[0] = 0;
								for(i = 0; buffer[i] != 0; i++){
									chb[0] = buffer[i];
									if(sbracket == 1){
										if(chb[0] == ']'){
											size_t ind = sindexof(sbracket_buffer, "|");
											sbracket_buffer[ind == -1 ? sstrlen(sbracket_buffer) : ind] = 0;

											char* key = sbracket_buffer;
											char* value = sbracket_buffer + (ind == -1 ? 0 : (ind + 1));
											if(strcmp(key, "Category") == 0){
												int j = 0;
												char* category_buffer = malloc(1);
												category_buffer[0] = 0;
												int category_bcounter = 0;
												while(1){
													if(value[j] == 0 || value[j] == '|'){
														if(category_bcounter != 0){
															categories = realloc(categories, sizeof(*categories) * (category_count + 2));
															categories[category_count] = sstrdup(category_buffer);
															categories[category_count + 1] = NULL;
															category_count++;
														}
														free(category_buffer);
														category_buffer = malloc(1);
														category_buffer[0] = 0;
														category_bcounter = 0;
														if(value[j] == 0) break;
													}else{
														category_buffer = realloc(category_buffer, category_bcounter + 2);
														category_buffer[category_bcounter] = value[j];
														category_buffer[category_bcounter + 1] = 0;
														category_bcounter++;
													}
													j++;
												}
												free(category_buffer);
											}else if(strcmp(key, "Title") == 0){
												free(name);
												name = sstrdup(value);
											}
											sbracket = 0;
											free(sbracket_buffer);
											sbracket_buffer = malloc(1);
											sbracket_buffer[0] = 0;
										}else{
											char* tmp = sbracket_buffer;
											sbracket_buffer = sstrcat(tmp, chb);
											free(tmp);
										}
										continue;
									}
									if(chb[0] == '['){
										sbracket = 1;
									}
								}
							}
							free(buffer);
							buffer = malloc(1);
							buffer[0] = 0;
							counter = 0;
							if(feof(f)) break;
						}else{
							buffer = realloc(buffer, counter + 2);
							buffer[counter] = ch;
							buffer[counter + 1] = 0;
							counter++;
						}
					}
					free(buffer);
					fclose(f);
				}
				free(path);
				int i;
				char matched = 0;
				for(i = 0; categories[i] != NULL; i++){
					if(strcmp(categories[i], category) == 0){
						matched = 1;
						break;
					}
				}
				if(matched == 1){
					char letter = '*';
					if('a' <= name[0] && name[0] <= 'z'){
						letter = name[0] - 0x20;
					}else if('A' <= name[0] && name[0] <= 'Z'){
						letter = name[0];
					}
					*entries = realloc(*entries, sizeof(**entries) * ((*entry_count) + 2));
					struct nikkel_entry* ent = malloc(sizeof(*ent));
					ent->name = sstrdup(name);
					ent->original_name = sstrdup(orig_name);
					ent->letter = letter;
					ent->prefix = sstrdup(prefix);
					ent->entryprefix = sstrdup(entryprefix);
					(*entries)[(*entry_count)] = ent;
					(*entries)[(*entry_count) + 1] = NULL;
					(*entry_count)++;
				}
				for(i = 0; categories[i] != NULL; i++) free(categories[i]);
				free(categories);
				free(name);
				free(orig_name);
			}
		}
		closedir(dir);
	}

}

char* nikkel_parse_category(struct nikkel_config* config, char* category){
	char* result = malloc(1);
	result[0] = 0;
	struct nikkel_entry** entries = malloc(sizeof(*entries));
	entries[0] = 0;
	int entry_count = 0;
	nikkel_dir(config->c_wikipath, &entries, &entry_count, category, config->c_prefix, "");
	int i;
	char ch = 'A';
	char match = 0;
	int matched_count = 0;
	for(ch = 'A'; ch != '['; ch++){
		int j;
		char first = 0;
		char* tmp;
		for(i = 0; entries[i] != NULL; i++){
			if(entries[i]->letter == ch){
				matched_count++;
				match = 1;
				if(first == 0){
					char* chb = malloc(2);
					chb[0] = ch;
					chb[1] = 0;
					tmp = result;
					result = sstrcat4(tmp, "<h3 id=\"char-", chb, "\"><span>");
					free(tmp);
					tmp = result;
					result = sstrcat(tmp, chb);
					free(tmp);
					tmp = result;
					result = sstrcat4(tmp, "</span> <a href=\"#char-", chb, "\">&#167;</a></h3>");
					free(tmp);
					free(chb);

					tmp = result;
					result = sstrcat(tmp, "<ul>");
					free(tmp);

					first = 1;
				}
				char* tmp;
				tmp = result;
				result = sstrcat4(tmp, "<li><a href=\"", entries[i]->prefix, "/");
				free(tmp);

				tmp = result;
				result = sstrcat4(tmp, entries[i]->original_name, "\">", entries[i]->entryprefix);
				free(tmp);

				tmp = result;
				result = sstrcat(tmp, entries[i]->name);
				free(tmp);

				tmp = result;
				result = sstrcat(tmp, "</a></li>");
				free(tmp);
			}
		}
		if(first == 1){
			tmp = result;
			result = sstrcat(tmp, "</ul>");
			free(tmp);
		}
	}
	for(i = 0; entries[i] != NULL; i++){	
		free(entries[i]->name);
		free(entries[i]->original_name);
		free(entries[i]->prefix);
		free(entries[i]->entryprefix);
		free(entries[i]);
	}
	free(entries);
	if(match == 0){
		free(result);
		result = sstrdup("Couldn't find the article which is in the category.");
	}else{
		char* matched_str = malloc(513);
		memset(matched_str, 0, 513);
		sprintf(matched_str, "There are %d articles which are in the category.<hr>", matched_count);
		char* tmp = result;
		result = sstrcat(matched_str, tmp);
		free(matched_str);
		free(tmp);
	}
	return result;
}
